#!/usr/bin/env python
# -*- coding: UTF-8 -*-

__authors__ = "joel"
__date__ = "octobre 2003"

'''
Remplissage de l'annuaire à partir d'un fichier ldif
'''

import os
from scribe.backend_conf import *
import getopt 
import sys

def usage () :
    print """  arguments:
                -f "fichier ldif"
                -v avec vérifiction des memberuid
                -h aide
  exemple ./lance-ldif.py -f fichier.ldif -v
  """

def traitement (ldif,verification):
    if verification==1 :
        ldif=verifie(ldif)
    # gestion des \ pour les partages et rép perso
    ldif=ldif.replace("\\","\\\\")
    cmd = "/bin/echo \""+ldif+"\" | ldapadd -x -D cn=admin,o=gouv,c=fr -w "+ldap_passwd+" > /dev/null"
    r = os.system(cmd)
    if r != 0 :
        if r==17408 :
            print "erreur d'ajout ldif ("+ldif.split('\n',1)[0]+")\n"
        elif r==5120 :
            print "erreur de modification ldif ("+ldif+")\n"
        else :
            print "erreur inconnue sur ("+ldif.split('\n',1)[0]+")\n"

# fin traitement

def verifie(ldif):
    ret=""
    for ligne in ldif.split('\n') :
        try:
            membre = ligne[ligne.index('memberUid: ')+11:]
            toto = os.system("id -u "+membre+" >/dev/null 2>&1 ")
            if toto==0 :
                ret+=ligne+'\n'
        except:
            ret+=ligne+'\n'
    return ret
# fin verifie

def main():
    # récupération des arguments de la ligne de commande
    try:
        options, args = getopt.getopt(sys.argv[1:],'f:vh', ['fichier=','verification','help'])

    except getopt.GetoptError:
        er_type, er_value, er_traceback = sys.exc_info()
        er_msg = str(er_value)
        sys.exit("l'option -%s est inconnue ou nécessite un argument" % er_msg[er_msg.index('-')+1])

    verification=0
    for (opt,val) in options:
        if (opt == '-f') or (opt == '--fichier'):
            fichier=val
        elif (opt == '-v') or (opt == '--verification'):
            verification=1
        elif (opt == '-h') or (opt == '--help'):
            usage()
            sys.exit(0)
    
    try :
        fp=open(fichier,'r')
    except :
        print "Impossible d'ouvrir le fichier "+fichier
        sys.exit(0)

    texte=fp.read()
    
    separateur='''

''';
    
    compt=0
    for ldif in texte.split(separateur) :
        if ldif :
            traitement(ldif,verification)
            compt=compt+1
            if compt % 200 == 0:
                print "%d actions réalisées"%compt
    print "TOTAL : %d actions réalisées"%compt

if __name__ == '__main__':
    main()
