#!/usr/bin/env python
# -*- coding: UTF-8 -*-

__authors__ = "joel"
__date__ = "octobre 2003"

import os
from scribe.backend_conf import *
from creole import parsedico
import getopt 
import sys

def usage () :
    print """
    Destruction d'entrées en masse dans l'annuaire
    
    arguments:
                -i attribut identifiant des entrées à détruire (cn, uid,...)
                -c objectclass des entrées à détruire
                -b sous-branche de recherche (à partir de l'etablissement)
                -h aide

  exemple ./supprime-branche.py -i uid -c eleves -b 'ou=local,ou=eleves,ou=utilistateurs'
  """

def traitement (id,classe,branche):
	
    # recherche des entrées à détruire 
    cmd = "ldapsearch -x -D cn=admin,o=gouv,c=fr -w "+ldap_passwd+" -s sub -LLL '(objectclass="+classe+")' "+id
    try :
        entree, sortie = os.popen2(cmd)
    except:
        print "Erreur de recherche des objets "+classe
        sys.exit(0)
    resultat = sortie.read()
    for ligne in resultat.split('\n') :
        if ligne :
            # recherche des "dn"
            if ligne.startswith(id+': ') :
                ligne=ligne[4:]
                cmd = "ldapdelete -x -D cn=admin,o=gouv,c=fr -w '"+ldap_passwd+"' '"+id+"="+ligne+","+branche+"'"               
                #print os.system(cmd)
                if(os.system(cmd)==8192):
                    print "Erreur de suppression de "+ligne+" ("+classe+")"
                #    print cmd
                #    sys.exit(0)
# fin traitement

def main():
    # récupération des arguments de la ligne de commande
    try:
        options, args = getopt.getopt(sys.argv[1:],'i:c:b:h', ['identifiant=','classe=','branche','help'])

    except getopt.GetoptError:
        er_type, er_value, er_traceback = sys.exc_info()
        er_msg = str(er_value)
        sys.exit("l'option -%s est inconnue ou nécessite un argument" % er_msg[er_msg.index('-')+1])

    for (opt,val) in options:
        if (opt == '-i') or (opt == '--identifiant'):
            id=val
        elif (opt == '-c') or (opt == '--classe'):
            classe=val
        elif (opt == '-b') or (opt == '--branche'):
            branche=val
        elif (opt == '-h') or (opt == '--help'):
            usage()
            sys.exit(0)
    
    dicoEole = parsedico.parse_dico()
    branche=branche+',ou='+dicoEole["numero_etab"]+',ou='+dicoEole["nom_academie"]+',ou=education,o=gouv,c=fr'
    #try :
    traitement(id,classe,branche)
    #except :
    #    usage()
    #    sys.exit(0)

if __name__ == '__main__':
    main()
                                    
