#!/usr/bin/env python
# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# Parseur DOM pour fichiers XML issus de AAF
#
###########################################################################

import xml.dom.minidom
import sys
                                                                                                                                                            
                                                                                                                                                            
def get_text_node(node):
    """
    @param node: node minidom contenant du texte
    Utilitaire minidom permettant de récupérer le texte d'un node texte
    """
    texte = ""
    nodelist = node.childNodes
    for textnode in nodelist:
        if textnode.nodeType == textnode.TEXT_NODE:            
            texte = texte + textnode.data
    return texte

def open_file(filename, mode):
    try:
        return file(filename, mode)
    except:
        print "Impossible d'ouvrir le fichier %s"%filename
        sys.exit()

def parse_xml_file(filename):
    """
    parsing du fichier XML AAF
    """
    print "lecture du fichier..."
    document = xml.dom.minidom.parse(filename)
    root_node = document.documentElement
    for request in root_node.getElementsByTagName('addRequest'):
        for operational in request.getElementsByTagName('operationalAttributes'):
            attr = operational.getElementsByTagName('attr')[0]
            print attr.getAttribute("name"), ":", get_text_node(attr.getElementsByTagName('value')[0])
        for identifier in request.getElementsByTagName('identifier'):
            print "identifiant :", get_text_node(identifier.getElementsByTagName('id')[0])
        for attributes in request.getElementsByTagName('attributes'):
            for attr in attributes.getElementsByTagName('attr'):
                value = ''
                for val in attr.getElementsByTagName('value'):
                    if value != '':
                        # FIXME : séparateur (1) 
                        value += ' '
                    value += get_text_node(val)
                if value != '':
                    # FIXME : séparateur(2)
                    value.replace('$', ' ')
                    # encode pour affichage uniquement
                    print attr.getAttribute("name"), ":", value.encode('iso-8859-1')
                else:
                    # attribut vide
                    pass
        print 
    # FIXME : deleteRequest
    print "Entrées supprimées"
    for request in root_node.getElementsByTagName('deleteRequest'):
        for operational in request.getElementsByTagName('operationalAttributes'):
            attr = operational.getElementsByTagName('attr')[0]
            print attr.getAttribute("name"), ":", get_text_node(attr.getElementsByTagName('value')[0])
        for identifier in request.getElementsByTagName('identifier'):
            print "identifiant :", get_text_node(identifier.getElementsByTagName('id')[0])
        
                    
    ### recuperation des affectations des classes et des groupes
    #division,groupes = parse_structures(root_node.getElementsByTagName('STRUCTURES')[0])
    ### recuperation des adresses renseignées
    #adresses = parse_adresses(root_node.getElementsByTagName('ADRESSES')[0])
    ### recuperation des eleves
    #parse_eleves(root_node.getElementsByTagName('ELEVES')[0], division,groupes,adresses)

                                                                                                                                                            
if __name__ == "__main__":    
    try:
        aaf_file = sys.argv[1]
    except:
        sys.exit("usage : %s <fichier.xml>"%sys.argv[0])
    # test du fichier
    f_xml = open_file(aaf_file, 'r')
    f_xml.close()
    parse_xml_file(aaf_file)

