#!/bin/bash

# Finalisation de l'extraction GEP
# Appel des scripts de finalisation

# Fichier de LOG
F_LOG='./tmp/rapport.txt'
> $F_LOG

echo "## RAPPORT d'EXECUTION des SCRIPTS pour Extraction Scribe ##" >> $F_LOG
echo "" >> $F_LOG
echo "--  arrêt de certains services --" >> $F_LOG
sudo /etc/init.d/sympa stop >> $F_LOG 2>&1
sudo /etc/init.d/samba   stop >> $F_LOG 2>&1
sudo /etc/init.d/controle-vnc stop >> $F_LOG 2>&1
echo "" >> $F_LOG
echo "--  Suppression des répertoires pour les utilisateurs et groupes supprimés --" >> $F_LOG
sh ./tmp/delete.sh >> $F_LOG 2>&1
echo "" >> $F_LOG
# Vidange de l'annuaire : groupes + partages
echo "-- Suppression des entrées dans l'annuaire --" >> $F_LOG
echo "* suppression des groupes *" >> $F_LOG
sudo /usr/share/eole/backend/supprime-branche.py -i cn -c posixGroup -b 'ou=local,ou=groupes' >> $F_LOG 2>&1
echo "* suppression des partages *" >> $F_LOG
sudo /usr/share/eole/backend/supprime-branche.py -i cn -c sambaFileShare -b 'ou=local,ou=partages' >> $F_LOG 2>&1
# rm -rf /var/lib/ldap/*
echo "" >> $F_LOG
# Remplissage de l'annuaire
echo "-- Peuplement de l'annuaire --" >> $F_LOG
# pas besoin des détails !
echo "* Entrées du nouvel annuaire" >> $F_LOG
sudo /usr/share/eole/backend/lance-ldif.py -f ./tmp/annuaire.ldif >> $F_LOG
echo "* Récupération des groupes reconduits" >> $F_LOG
# (avec vérif des memberuid : -v)
sudo /usr/share/eole/backend/lance-ldif.py -f ./tmp/sauve.ldif -v >> $F_LOG
# inscription des nouveaux professeurs
sudo /usr/share/eole/backend/lance-ldif.py -f ./tmp/admins.ldif >> $F_LOG
#/usr/bin/ldapadd -x -D "cn=admin,o=gouv,c=fr" -w eole21 -f ./tmp/annuaire.ldif >> $F_LOG 2>&1
echo "" >> $F_LOG
echo "-- Synchronisation --" >> $F_LOG 
# faire un chown même si le rép existe ?
sudo /usr/share/eole/backend/synchro_file.py norestart >> $F_LOG 2>&1
echo "" >> $F_LOG
echo "-- Mise à jour des mots de passe et des répertoires pour les nouveaux utilisateurs --" >> $F_LOG
# vérifier la présence du fichier dans sudoers
chmod u+x ./tmp/passwd.sh >> $F_LOG 2>&1
sudo ./tmp/passwd.sh >> $F_LOG 2>&1
echo "" >> $F_LOG
echo "--  redémarrage des services --" >> $F_LOG
sudo /etc/init.d/sympa start >> $F_LOG 2>&1
sudo /etc/init.d/samba   start >> $F_LOG 2>&1
sudo /etc/init.d/controle-vnc start >> $F_LOG 2>&1
echo "" >> $F_LOG
echo "-- Création des listes de diffusion --" >> $F_LOG
sh ./tmp/sympa.sh >> $F_LOG 2>&1
# forcer la mise à jour des listes SYMPA
echo "sudo /usr/share/ead/force-listes.sh" | at now + "5 minutes" 2> /dev/null
echo "" >> $F_LOG
echo "## fin ##" >> $F_LOG
