<?

// on se donne + de temps et de mémoire que d'habitude
$old=ini_set("max_execution_time",1000);
$old2=ini_set("memory_limit","64M");

/*
-- Ancienne version en PERL --
my $copyright = "\n";
$copyright .= "    gen-ldif v. $version.\n\n";
$copyright .= "    Copyright (c) 2003 Joel Cuissinat <joel.cuissinat\@ac-dijon.fr>\n";
$copyright .= "    Copyright (c) 2002 Kévin Reverchon <kreverchon\@ac-dijon.fr>.\n\n";
$copyright .= "    gen-ldif EST UN LOGICIEL LIBRE. SE RÉFÉRER AU CODE SOURCE\n";
$copyright .= "    POUR LA LICENCE D'UTILISATION ET DE COPIE.\n\n";
*/

// fichier de config principal
include_once ('./inc/constantes.php');

// fonctions utilisées
require_once ('./inc/fonctions.php');

// test d'ouverture des fichiers (entrée)
if (!($fe=fopen($f_eleve,"r"))) {
   print "Erreur d'ouverture de $f_eleve";exit;
}
if (!($fp=fopen($f_prof,"r"))) {
   print "Erreur d'ouverture de $f_prof";exit;
}

// test d'ouverture des fichiers (sortie)
if (!($fl=fopen($f_ldif,"w"))) {
   print "Erreur d'ouverture de $f_ldif";exit;
}
if (!($fs=fopen($f_sympa,"w"))) {
   print "Erreur d'ouverture de $f_sympa";exit;
}
if (!($fw=fopen($f_passwd,"w"))) {
   print "Erreur d'ouverture de $f_passwd";exit;
}
if (!($fa=fopen($f_admin,"w"))) {
   print "Erreur d'ouverture de $f_admin";exit;
}
if (!($fi=fopen($f_info,"w"))) {
   print "Erreur d'ouverture de $f_info";exit;
}
// en-tête fichier CSV
$txt="CLASSE;NOM;PRENOM;LOGIN;MOT DE PASSE\n";

// test de connexion à l'annuaire
if (!$ds=connexion_ldap()) {
   print "Erreur de connexion à l'annuaire";exit;
}

// récupération du SID
if (!$sid=exec("sudo /usr/bin/net getlocalsid | awk -F: '{print $2}' | awk -F \" \" '{print $1}'")) {
   print "Impossible de récupérer le SID";exit;
}

// initialisations
$buf_groupe="";
$buf_pass="";
$buf_list="";
$new_users=array();

// récupération des anciens groupes (tab["nom"]=numéro)
$pre_groupes=array(); //init
$tab_groupe=array(); //init
$sr = ldap_search($ds,$branch_groupe,'objectClass=posixGroup',array('cn','gidnumber'));
$info = ldap_get_entries($ds, $sr);
for ($i=0;$i<$info['count'];$i++) {
   $cn=$info[$i]['cn'][0];
   $pre_groupes[$cn]=$info[$i]['gidnumber'][0];
}

// récupération des anciens utilisateurs (tab["nom"]=numéro)
$pre_users=array(); //init
$login_attribues=array(); //init
//*élèves*
$sr = ldap_search($ds,$branch_eleve,'objectClass=posixAccount',array('uid','uidnumber'));
$info = ldap_get_entries($ds, $sr);
for ($i=0;$i<$info["count"];$i++) {
   $uid=$info[$i]['uid'][0];
   $pre_users[$uid]=$info[$i]['uidnumber'][0];
}
//*professeurs*
$sr = ldap_search($ds,$branch_admin,'objectClass=posixAccount',array('uid','uidnumber'));
$info = ldap_get_entries($ds, $sr);
for ($i=0;$i<$info["count"];$i++) {
   $uid=$info[$i]['uid'][0];
   $pre_users[$uid]=$info[$i]['uidnumber'][0];
}

// groupes principaux particuliers (voir si on fixe les gid ?)
//*professeurs*
list($gid_eleves,$new)=gestion_groupes("eleves");
$buf_groupe .= nouveau_groupe($sid,$gid_eleves,"eleves","eleves",0);
//$groupid_eleves=2*$gid_eleves+1001;
//*élèves*
list($gid_professeurs,$new)=gestion_groupes("professeurs");
$buf_groupe .= nouveau_groupe($sid,$gid_professeurs,"professeurs","professeurs",1);
//$groupid_professeurs=2*$gid_professeurs+1001;

// réinitialisation des liens vers les classes
$buf_pass.="#!/bin/bash\n";
$buf_pass.=Copie_admin();
$buf_pass.="rm -rf /home/classes/*\n";

// choix du domaine : restreint/internet
if ($dmess=="internet")
   $dchoisi="$domaine";
else
   $dchoisi="i-$domaine";


#----------------------------------------------------------------------------------------------
#                           etape1: lecture des données du fichier d'entrée (élèves)
#                                    et préparation au maniement des données
#----------------------------------------------------------------------------------------------

#-----------------------------------------------------------------------------------------------
#                               description des indices de @vect_lignes
#-----------------------------------------------------------------------------------------------
# 0:ELENEOT(n° élève), 1:ELENOM, 2:ELREPRE, 3:ELESEXE, 4:ELEDATENAISS, 5:MEFLCF(niveau ou section), 
# ?6:MEFLC_MSO, ?7:MEFLCM, 8:DIVCOD(classe), ?9:DIVCOD_MSO, ?10:ERENO(n° responsable), 11:ADRESSE
#-----------------------------------------------------------------------------------------------

// parcours du fichier élève
while ($ligne=fgets($fe,1024)) {
   
   // suppression des caractères spéciaux
   $ligne=dbase_filter($ligne);
   $ligne=replace_car($ligne);
   // récupération de tous les champs   
   list($num,$nom,$prenom,$sexe,$date,$niveau,$classe,$adresse,$force_login,$force_mdp)
       =split(":",$ligne,10);
   
   // GESTION des GROUPES (élèves)
   // homonymes (sconet seulement)
   if (isset($renommage) and array_key_exists($classe,$renommage)) $classe=$renommage[$classe];
   $classe=strtolower($classe);
   $niveau=strtolower($niveau);
   $equipe = "profs-$classe";
   list($gid_equipe,$nouvelle_equipe)=gestion_groupes($equipe);
   list($gid_classe,$nouvelle_classe)=gestion_groupes($classe);
   list($gid_niveau,$nouveau_niveau)=gestion_groupes($niveau);
   
   // gestion du login
   $prenom1=premier($prenom);
   $nom1=premier($nom);

   // test de préexistence élève sur le ELENOET et la date de naissance
   $filtre="(&(employeeNumber=$num)(dateNaissance=$date))";
   // recherche de l'élève (on récup que l'uid)
   $sr = ldap_search($ds,$branch_eleve,$filtre,array("uid"));
   $info = ldap_get_entries($ds, $sr);
   if ($info["count"] == 1) {
      // cas 1 : trouvé dans l'annuaire
      $login=$info[0]["uid"][0];
      if (array_key_exists($login,$login_attribues)) {
         // sauter l'utilisateur
	 print "$prenom1 $nom en double<br>";
	 continue;
      }
      $eleves_conserves++;
      // il reserve son login :>
      $login_attribues[$login]=$pre_users[$login];
      // création du ldif MODIFY élève (dans $entree)
      include('./inc/modifie-eleve.php');
      fwrite($fl,$entree);
      $pwd="";
   }
   else {
      // cas 2 : nouvel élève
      $nouveaux_eleves++;
      if (! $force_login) {
      # Todo : fonction si cas supplémentaires + idem profs
          if ($logintype == "pnom") {
	      $login=$prenom1[0].$nom1;
	  }else{
              $login=$prenom1.".".$nom1;
	  }
      } else {
          // login forcé (txt)
          $login=$force_login;
      }
      $login=prepare_login($login);
      // essaie de trouver un login libre :<
      list($login,$uidnumber)=gestion_utilisateurs($login);
      //echo "Nouveau $login, $uidnumber<br>";
      // pas de jaloux
      $userpassword="xxx";
      $lmpassword  ="xxx";
      $ntpassword  ="xxx";
      // choix domaine restreint/internet
      $mail ="$login"."@"."$dchoisi";
      // mais il faudra mettre le mot de passe à jour !
      if ($force_mdp) {
         // mot de passe forcé (txt)
         $pwd=$force_mdp;
      } elseif ($passe=="naiss" && $date) {
         $pwd=reverse_date($date);
      }
      else {
         $pwd=Genere_mdp();
      }
      // création du ldif élève (dans $entree)
      include('./inc/modele-eleve.php');
      fwrite($fl,$entree);
      //samba3
      $new_users[]=$login;
      
   }//endif fichier
   
   if ($nouvelle_classe) {
      // association classe -> niveau ? plus utile ?
      $tab_niveau[$classe]=$niveau;
      // Création du groupe classe puis de son dossier partagé
      $buf_groupe .= nouvelle_classe($sid,$gid_classe,$classe, $niveau);
      // Création de la liste de diffusion sympa pour la classe [auparavant dans le prof ppal]
      $buf_list.=liste_sympa($classe,$admin_mail,"Classe");
   }
   if ($nouvelle_equipe==1) {
       $buf_groupe .= nouveau_groupe($sid,$gid_equipe,$equipe,"Equipe $equipe", 1);
       // Création de la liste de diffusion sympa pour l'équipe
       $buf_list.=liste_sympa($equipe,$admin_mail,"Equipe");
   }
			 
   // on conserve les infos pour les remettre dans l'ordre
   $eleves["$classe"]["$login"]['password']=$pwd;
   $eleves["$classe"]["$login"]['name']=$nom;
   $eleves["$classe"]["$login"]['surname']=$prenom;
   $Egepi["$num"] = $login;
   
   if ($nouveau_niveau) {
       // Création du groupe niveau [pas de partage]
       $buf_groupe .= nouveau_groupe($sid,$gid_niveau,$niveau,"Niveau $niveau",0);
       // Création de la liste de diffusion sympa pour le niveau
       $buf_list .= liste_sympa($niveau,$admin_mail,"Niveau");
   }
   // intégration de l'élève
   //$buf_groupe .= membre($login,$niveau);

   // MAJ des compteurs
   $total++;
   if (fmod($total,50)==0) {
      print "<font size=-1>$total utilisateurs traités...\n</font><br>";
      flush();
   }
} // endwhile

$nb_eleves=$total;
// fermeture fichier élèves entrée
fclose ($fe);

// Mise à jour des mots de passe, quotas et ajout dans les groupes eleves et classe
foreach (array_keys($eleves) as $classe) {
   fwrite ($fw,$buf_pass);
   // il y a eu un fwrite
   $buf_pass="echo \"Mise à jour des mots de passe et des répertoires pour la classe $classe\"\n";
   // suppression pour éviter la création de liens récursifs
   $buf_pass.="rm -f /home/workgroups/profs-$classe/classe\n";
   $buf_pass.="rm -f /home/workgroups/profs-$classe/eleves\n";
   $buf_pass.="/usr/share/ead/rep-classe.sh $classe\n";
   // l'ajout dans les groupes est effectué par classe
   $buf_groupe .= membre(array_keys($eleves["$classe"]),$classe);
   $buf_groupe .= membre(array_keys($eleves["$classe"]),$tab_niveau[$classe]);
   $buf_groupe .= membre(array_keys($eleves["$classe"]),"eleves");   
   foreach ($eleves["$classe"] as $login => $tab) {
      if ($tab["password"]) {
         $buf_pass.=$fpass." -u ".$login." -p ".$tab["password"]."\n";
	 $buf_pass.="/usr/share/ead/rep-eleve.sh ".$login." ".$classe." ".$quota."\n";
	 $buf_pass.="echo \"Bienvenue sur $domaine\" | mail $login@$dchoisi -s \"Ouverture de votre compte de messagerie\"\n";
	 $txt.="$classe;".$tab["name"].";".$tab["surname"].";$login;".$tab["password"]."\n";
      }
      else {
         // updater les liens pour les anciens élèves
         $buf_pass.="ln -sf /home/".$login[0]."/$login/perso /home/classes/$classe/$login\n";
	 $txt.="$classe;".$tab["name"].";".$tab["surname"].";$login;(déjà attribué)\n";
      }
   }
}
unset ($eleves);
	 

/*
#----------------------------------------------------------------------------------------------
#                           etape2 : lecture des données du fichier d'entrée (profs)
#                                    et préparation au maniement des données
#----------------------------------------------------------------------------------------------

#-----------------------------------------------------------------------------------------------
#                               description des indices de @vect_lignes
#-----------------------------------------------------------------------------------------------
# 0:nom, 1:prénoms, 2:sexe, 3:numéro, 4:classe, 5:date naissance, 6:matières, 7:classes
#-----------------------------------------------------------------------------------------------
*/


// parcours du fichier profs
while ($ligne=fgets($fp,1024)) {
   // suppression des caractères spéciaux
   $ligne=dbase_filter($ligne);
   $ligne=replace_car($ligne);
   // récupération de tous les champs   
   list($nom,$prenom,$sexe,$num,$classe,$date,$matiere,$enseigne,$discipline,$force_login,$force_mdp)
       =split(":",$ligne,11);
       
   // GESTION des GROUPES
   if (isset($renommage) and array_key_exists($classe,$renommage)) $classe=$renommage[$classe];
   $classe=strtolower($classe);
   if (($classe == "0") or ($classe == "")) {  
   // prof quelconque
      $classe="autre"; 
   }
   else {
   // prof ppal //
      list($gid_classe,$nouvelle_classe)=gestion_groupes($classe);
      if ($nouvelle_classe) {
         print "Erreur professeur $nom responsable de la classe $classe sans élèves !<br>";
      }
   }
   
   $prenom1=premier($prenom);
   $nom1=premier($nom);
   
   $filtre="(&(cn=$prenom $nom)(dateNaissance=$date))";
   $sr = ldap_search($ds,$branch_admin,$filtre);
   $info = ldap_get_entries($ds, $sr);
   if ($info["count"] != 1) {
      // cas célèbre où la date de naissance n'est pas renseignée dans GEP
      $filtre="(&(cn=$prenom $nom)(dateNaissance=0*))";
      $sr = ldap_search($ds,$branch_admin,$filtre);
      $info = ldap_get_entries($ds, $sr);
   }
   if ($info["count"] == 1) {
      // cas 1 : trouvé dans l'annuaire
      $login=$info[0]["uid"][0];
      if (array_key_exists($login,$login_attribues)) {
         // sauter l'utilisateur
	 print "$prenom1 $nom en double<br>";
	 continue;
      }
      $profs_conserves++;
      // récupère son uid+uidnumber
      $login_attribues[$login]=$pre_users[$login];
      // si date vide, pb d'initialisation annuaire
      if ($date=="") $date="00000000";
      // création du ldif MODIFY professeur (dans $entree)
      include('./inc/modifie-prof.php');
      fwrite($fl,$entree);
      $pwd="";
   }
   else {
      // cas 2 : nouveau professeur
      $nouveaux_profs++;
      if (! $force_login) {
         if ($logintype == "pnom") {
            $login=$prenom1[0].$nom1;
         }else{
            $login=$prenom1.".".$nom1;
         }
      } else {
          // login forcé (txt)
          $login=$force_login;
      }
      $login=prepare_login($login);
      // essaie de trouver un login libre :<
      list($login,$uidnumber)=gestion_utilisateurs($login);
      //echo "<font color=green>Nouveau prof : $prenom1 $nom (login attribué : $login)</font><br>" ;
      // pas de jaloux
      $userpassword="xxx";
      $lmpassword  ="xxx";
      $ntpassword  ="xxx";
      // plus de login en local
      //$mail        ="$login"."@"."i-$domaine";
      // mais il faudra mettre le mot de passe à jour (date de naissance) !
      // $passe== "naiss" | "alea"
      if ($force_mdp) {
         // mot de passe forcé (txt)
         $pwd=$force_mdp;
      } elseif ($passe=="naiss" && $date) {
         $pwd=reverse_date($date);
      }
      else {
         $pwd=Genere_mdp();
      }
      // si date vide, pb d'initialisation annuaire
      if ($date=="") $date="00000000";
      // création du ldif professeur (dans $entree)
      include('./inc/modele-prof.php');
      fwrite($fl,$entree);
      //samba3
      $new_users[]=$login;
   }

   // évidemment...
   $profs["$login"]["password"]=$pwd;
   $profs["$login"]["name"]=$nom;
   $profs["$login"]["surname"]=$prenom;
   $Pgepi["$num"] = $login;

   // GESTION des équipes pédagogiques
   if (is_array($classes=preg_split('/ /', $enseigne,-1,PREG_SPLIT_NO_EMPTY))) {
      $classes = array_unique($classes);
      foreach ($classes as $cl) {
         // parcours des classes dans lesquelles intervient le prof         
         if (isset($renommage) and array_key_exists(trim($cl),$renommage)) $cl = $renommage[trim($cl)];
	 $cl = strtolower(trim(($cl)));
	 if (array_key_exists($cl,$tab_niveau)) # classe répertoriée
         {
	    //$buf_groupe .= membre($login,$cl);
	    $buf_groupe .= membre($login,"profs-$cl");
	 }
         // nouvelle politique de masquage des erreurs
	 //else {
	 //   if ($cl) $error_classe.="$cl ";
	 //}
      }#end foreach
   }
   
   // GESTION des matières
   if (is_array($matieres=preg_split ('/ /', $matiere,-1,PREG_SPLIT_NO_EMPTY))) {
      // STS ajout de la matière aux disciplines (car risque d'homonymes :)
      //if ($extraction=="sconet" and $discipline) {
      //   $matieres[] = $discipline;
      //}
      $matieres = array_unique($matieres);
      foreach ($matieres as $mat) {
         // parcours des matières enseignées par le prof
	 $mat = strtolower($mat);
	 list($gid_mat,$nouvelle_mat) = gestion_groupes($mat);
	 if ($nouvelle_mat==1) {
	    // STS : on ne met un partage que pour les disciplines
	    //if ($extraction=="sconet") {
	    //   if ($mat == strtolower($discipline)) {
	    //      $buf_groupe .= nouveau_groupe($sid,$gid_mat,$mat,"Matiere $mat", 1);
	    //   }else{
	    //      $buf_groupe .= nouveau_groupe($sid,$gid_mat,$mat,"Matiere $mat", 0);
	    //   }
	    //}else{
	    $buf_groupe .= nouveau_groupe($sid,$gid_mat,$mat,"Matiere $mat", 1);
	    $buf_list.=liste_sympa($mat,$admin_mail,"Matiere");
	 }
	 $buf_groupe .= membre($login,$mat);
      }
   }

   // MAJ des compteurs
   $total++;
   if (fmod($total,50)==0) {
      print "<font size=-1>$total utilisateurs traités...\n</font>";
   }
} //endwhile

$nb_profs=$total-$nb_eleves;
// fermeture fichier profs entrée
fclose ($fp);

// Mise à jour des mots de passe, quotas et ajout dans les groupes professeurs
$buf_groupe .= membre(array_keys($profs),"professeurs");
$buf_pass.="echo \"Mise à jour des mots de passe et des répertoires pour les professeurs\"\n";
foreach ($profs as $login => $tab) {
   if ($tab["password"]) {
      $buf_pass.="sudo ".$fpass." -u ".$login." -p ".$tab["password"]."\n";
      $buf_pass.="sudo /usr/share/ead/rep-prof.sh ".$login." ".$qprof."\n";
      $txt.="professeurs;".$tab["name"].";".$tab["surname"].";$login;".$tab["password"]."\n";
   }
   else {
      $txt.="professeurs;".$tab["name"].";".$tab["surname"].";$login;(déjà attribué)\n";
   }
}

/*
#----------------------------------------------------------------------------------------------
#                           etape3 : écriture dans les fichiers 
#                                    et bilan des actions
#----------------------------------------------------------------------------------------------
*/

// fermeture fichier maj mots de passe
fwrite ($fw,$buf_pass);
fclose ($fw);

// ajouts des groupes dans le ldif
fwrite ($fl,$buf_groupe);
fclose ($fl);

// infos sur les comptes créés
fwrite ($fi,$txt);
fclose ($fi);

// ajout des listes sympa
#Eole1
$buf_list.="/usr/share/eole/backend/mailsync.py\n";
fwrite ($fs, $buf_list);
fclose ($fs);

// tous les nouveaux utilisateurs dans domainUsers (samba3)
if ($new_users != array()) {
   $admins=membre($new_users,"domainUsers");
}else{
   $admins="";
}
fwrite ($fa, $admins);
fclose ($fa);

// Fichiers spéciaux pour Gepi
if ($extraction == 'sconet' and file_exists('./tmp/prof_disc_classes.tmp')) {
   $fh = fopen('/tmp/prof_disc_classes.csv', 'w');
   $lines = file('./tmp/prof_disc_classes.tmp');
   foreach($lines as $line){
      list($num,$reste) = explode('#',$line,2);
      if ($Pgepi[$num]) {
         fwrite($fh,$Pgepi[$num].';'.$reste);
      }
   }
   fclose($fh);
}
if ($extraction == 'sconet' and file_exists('./tmp/eleves_options.tmp')) {
   //copy('./tmp/eleves_options.tmp', '/tmp/eleves_options.csv');
   $fh = fopen('/tmp/eleves_options.csv', 'w');
   $lines = file('./tmp/eleves_options.tmp');
   foreach($lines as $line){
      list($num,$reste) = explode('#',$line,2);
      if ($Egepi[$num]) {
         fwrite($fh,$Egepi[$num].';'.$reste);
      }
   }
      
}

// BILAN //
print "<br>";
// nouvelle politique de masquage des erreurs
//if ($error_classe) print "<font color=red>Erreur GEP : Classes non répertoriées :</font><br>[$error_classe]<br><br>\n";
//print $nouv;
print "=> $eleves_conserves élèves conservés et $nouveaux_eleves nouveaux élèves<br>\n";
print "=> $profs_conserves professeurs conservés et $nouveaux_profs nouveaux professeurs<br>\n";

print "<h2>Décochez les cases pour les élèves à ne pas effacer</h2>";
// gens qui restent élèves
$sr = ldap_search($ds,$branch_eleve,'(&(uid=*)(!(Divcod=ancien)))',array('uid','cn'));
$info = ldap_get_entries($ds, $sr);
echo restes ($info, $login_attribues,"eleves",$neleves);

/*print "<h2>Décochez les cases pour les ANCIENS élèves à ne pas effacer</h2>";
// gens qui restent élèves
$sr = ldap_search($ds,$branch_eleve,"(&(uid=*)(Divcod=ancien))");
$info = ldap_get_entries($ds, $sr);
echo restes ($info, $login_attribues,"eleves");*/

print "<h2>Décochez les cases pour les personnels à ne pas effacer</h2>";
// gens qui restent profs
$sr = ldap_search($ds,$branch_admin,'(uid=*)',array('uid','cn'));
$info = ldap_get_entries($ds,$sr);
echo restes ($info, $login_attribues,"profs",$nprofs);
print "<br>";
// groupes qui restent 
print "<h2>Groupes non retrouvés</h2>";
$buf="<table>"; $n=1;
if ($ngroupes) $check="CHECKED";
else $check="";
foreach (array_diff($pre_groupes,$tab_groupe) as $nom => $nb) {
   // protection des groupes spéciaux
   if (in_array($nom, array("DomainAdmins","PrintOperators","DomainComputers","DomainUsers")))
      $val="<input type=checkbox name='case_groupes[".$n."]' DISABLED> effacer $nom &nbsp";
   else
      $val="<input type=checkbox name='case_groupes[".$n."]' $check> effacer $nom &nbsp";
   $buf.="<input type=hidden name='tab_groupes[".$n."]' value='$nom'>";
   if ($n++&1) $buf.="<tr><td>$val</td>\n"; // ligne impaire
   else $buf.="<td>$val</td></tr>\n"; // ligne paire
}
echo $buf."</table>";

// remet l'ancienne valeur !
//ini_set("max_execution_time",$old);
//ini_set("memory_limit",$old2);

?>
