<?
/*
   Fonctions utilisées dans gen_ldif.php
*/

// Traitement des caractères spéciaux
// (source : http://www.phpapps.org)
function replace_car($string){
$Caracs = array("¥" => "Y", "µ" => "u", "À" => "A", "Á" => "A",
                "Â" => "A", "Ã" => "A", "Ä" => "A", "Å" => "A", 
		"Æ" => "A", "Ç" => "C", "È" => "E", "É" => "E", 
		"Ê" => "E", "Ë" => "E", "Ì" => "I", "Í" => "I", 
		"Î" => "I", "Ï" => "I", "Ð" => "D", "Ñ" => "N", 
		"Ò" => "O", "Ó" => "O", "Ô" => "O", "Õ" => "O", 	
		"Ö" => "O", "Ø" => "O", "Ù" => "U", "Ú" => "U", 
		"Û" => "U", "Ü" => "U", "Ý" => "Y", "ß" => "s",
		"à" => "a", "á" => "a", "â" => "a", "ã" => "a",
		"ä" => "a", "å" => "a", "æ" => "a", "ç" => "c", 
		"è" => "e", "é" => "e", "ê" => "e", "ë" => "e", 
		"ì" => "i", "í" => "i", "î" => "i", "ï" => "i", 
		"ð" => "o", "ñ" => "n", "ò" => "o", "ó" => "o", 
		"ô" => "o", "õ" => "o", "ö" => "o", "ø" => "o", 
		"ù" => "u", "ú" => "u", "û" => "u", "ü" => "u", 
		"ý" => "y", "ÿ" => "y", "~B"=> "e"); 
   return strtr($string, $Caracs);
}


// Traitement de caractères spéciaux
// (source GEPI)
function dbase_filter($s){
  $s=trim($s);
  for($i = 0; $i < strlen($s); $i++){
      $code = ord($s[$i]);
      switch($code){
        case 129:   $s[$i] = "u" ; break;//"ü"; break;
        case 130:   $s[$i] = "e" ; break;//"é"; break;
        case 131:   $s[$i] = "a" ; break;//"â"; break;
        case 132:   $s[$i] = "a" ; break;//"ä"; break;
        case 133:   $s[$i] = "a" ; break;//"à"; break;
        case 135:   $s[$i] = "c" ; break;//"ç"; break;
        case 136:   $s[$i] = "e" ; break;//"ê"; break;
        case 137:   $s[$i] = "e" ; break;//"ë"; break;
        case 138:   $s[$i] = "e" ; break;//"è"; break;
        case 139:   $s[$i] = "i" ; break;//"ï"; break;
        case 140:   $s[$i] = "i" ; break;//"î"; break;
        case 147:   $s[$i] = "o" ; break;//"ô"; break;
        case 148:   $s[$i] = "o" ; break;//"ö"; break;
        case 150:   $s[$i] = "u" ; break;//"û"; break;
        case 151:   $s[$i] = "u" ; break;//"ù"; break;
	// et parce qu'il y en a !
	case 176:   $s[$i] = "." ; break;//°
	case 248:   $s[$i] = "o" ; break;//ø
      }
   }
   return $s;
}
									      
// Traitement des caractères spéciaux
// (source : http://www.phpapps.org)
function prepare_login($string){
   // longueur MAX (prendre en compte les doublons)
   $maxlen=19;
   if (strlen($string)>$maxlen) {
      $string=substr($string,0,$maxlen);
   }
   $string=strtolower($string);
   
$Caracs = array("¥" => "Y", "µ" => "u", "À" => "A", "Á" => "A",
                "Â" => "A", "Ã" => "A", "Ä" => "A", "Å" => "A", 
		"Æ" => "A", "Ç" => "C", "È" => "E", "É" => "E", 
		"Ê" => "E", "Ë" => "E", "Ì" => "I", "Í" => "I", 
		"Î" => "I", "Ï" => "I", "Ð" => "D", "Ñ" => "N", 
		"Ò" => "O", "Ó" => "O", "Ô" => "O", "Õ" => "O", 	
		"Ö" => "O", "Ø" => "O", "Ù" => "U", "Ú" => "U", 
		"Û" => "U", "Ü" => "U", "Ý" => "Y", "ß" => "s",
		"à" => "a", "á" => "a", "â" => "a", "ã" => "a",
		"ä" => "a", "å" => "a", "æ" => "a", "ç" => "c", 
		"è" => "e", "é" => "e", "ê" => "e", "ë" => "e", 
		"ì" => "i", "í" => "i", "î" => "i", "ï" => "i", 
		"ð" => "o", "ñ" => "n", "ò" => "o", "ó" => "o", 
		"ô" => "o", "õ" => "o", "ö" => "o", "ø" => "o", 
		"ù" => "u", "ú" => "u", "û" => "u", "ü" => "u", 
		"ý" => "y", "ÿ" => "y", "~B"=> "e"); 
   return strtr($string, $Caracs);
}

// Renommage des groupes pouvant poser des problèmes 
/*
 - suppression des espaces
 - remplacement "*" par "e"
 - gestion des groupes 100% numériques (bug n° 257)
 */
function ok_groupe($groupe, $type='g') {
   //$groupe = ereg_replace('[ ]+', " ", $groupe) ; //espaces
   if ($type=='n') {
      // niveau coupé au 1er espace
      $groupes = explode(" ", $groupe);
      $groupe = $groupes[0];
   }
   $groupes = explode('\(',$groupe);
   $groupe = $groupes[0];
   $groupe = ereg_replace('[ ]+', "", $groupe) ; //espaces
   $groupe = ereg_replace('\*', "e", $groupe) ;  // etoile (ex : mp*)
   $groupe = ereg_replace('\.', "", $groupe) ;    // "."
   $groupe = ereg_replace(':', "", $groupe) ;    // ":"
   $groupe = ereg_replace('=', "", $groupe) ;    // "="
   $groupe = ereg_replace('"', "", $groupe) ;    // '"'
   // groupes 100% numériques
   if (preg_match( '/^[0-9]+$/', $groupe)) {
      // ajout du prefixe "type"
      $groupe = $type.$groupe;
   }
   return $groupe;
}


// premier elt d'une liste de type 'un deux trois'
function premier ($str) {
   // débuggage : exceptions à traiter

   $de  =array("/'/","/^DE /","/^DU /","/^DELA /","/^DOS /","/^DI /","/^ES /","/^EL /","/^LE /","/^LA /","/^DA /","/^VAN /","/^BEN /");
   
   $vers=array(""   ,"DE"    ,"DU"    ,"DELA"    ,"DOS"    ,"DI"    ,"ES"    ,"EL"    ,"LE"    ,"LA"    ,"DA"    ,"VAN",    "BEN");
   $str=preg_replace($de,$vers,$str);
   $tab=preg_split ('/ |-/', $str,-1);
   return($tab[0]);
}


// date à l'anglaise pour annuaire (en=>fr)
function reverse_date($date) {
   // rappel : substr($chaine, $position_depart, $nb_caractères)
   return (substr($date,6,2).substr($date,4,2).substr($date,0,4));
}
// fr=>en
function reverse_date2($date) {
   // rappel : substr($chaine, $position_depart, $nb_caractères)
   return (substr($date,4,4).substr($date,2,2).substr($date,0,2));
}


// gestion des groupes
// attribution des bons gid etc...
function gestion_groupes($groupe) {

global $gid_courant, $tab_groupe;
global $pre_groupes; // groupes précédemment définis dans l'annuaire

   // Groupes attribués cette année
   if (array_key_exists($groupe, $tab_groupe)) {
      // déjà créé cette année
      //echo "Vu $groupe ($nb)<br>";
      return (array($tab_groupe[$groupe], 0)) ; // gidnumber + nouveau=0
   }
   
   // Groupes de l'année précédente
   if (array_key_exists($groupe, $pre_groupes)) {
         // connu l'année précédente
	 $tab_groupe[$groupe] = $pre_groupes[$groupe]; // ajouté aux groupes connus
	 return (array($pre_groupes[$groupe], 1)) ; // gidnumber + nouveau=1
   }

   // le pire cas : non créé cette année ni l'année précédente !
   // il faut attribuer un gid LIBRE
   $cpt=$gid_courant;
   
   while (in_array($cpt,$pre_groupes) || in_array($cpt,$tab_groupe)) {
      $cpt++;
   }
   $gid_courant=$cpt+1;
   $tab_groupe[$groupe]=$cpt;
   return (array($cpt,1));
}

// gestion des utilisateurs
// attribution des bons uid etc... (sur le modèle des groupes)
function gestion_utilisateurs($login) {

// On n'arrive ici que lorsqu'il s'agit d'un nouveau user 
global $uid_courant, $login_attribues;
global $pre_users; // utilisateurs précédemment définis dans l'annuaire

   $nb_doub=0; // extension chiffrée éventuelle du login
   $login_propose=$login;
   
   while (array_key_exists($login_propose,$login_attribues) || array_key_exists($login_propose,$pre_users)) {
   // tant que le login est déjà pris, on incrémente l'extension
      $nb_doub++;
      $login_propose=$login.$nb_doub;
   }
   $login=$login_propose;

   // Non créé cette année ni l'année précédente !
   // il faut attribuer un uid LIBRE
   $cpt=$uid_courant;
   
   while (in_array($cpt,$pre_users) || in_array($cpt,$login_attribues)) {
      $cpt++;
   }
   $uid_courant=$cpt+1;
   $login_attribues[$login]=$cpt;
   return (array($login,$cpt));
}


// création d'un groupe classe et de son partage
// différencié des autres groupes par : l'objectClass:classe
function nouvelle_classe ($sid, $gid, $groupe, $niveau) {
   global $samba_server, $racine;
   $rid=2*$gid+1001;
   // groupe
   $buf = "dn:cn=$groupe,ou=local,ou=groupes,$racine\n";
   $buf .= "objectClass:sambaGroupMapping\n";
   $buf .= "objectClass:posixGroup\n";
   $buf .= "objectClass:classe\n";
   $buf .= "cn:$groupe\n";
   $buf .= "gidNumber:$gid\n";
   $buf .= "sambaGroupType:2\n";
   $buf .= "sambaSID:$sid-$rid\n";
   $buf .= "description:Classe $groupe\n";
   $buf .= "niveau:$niveau\n\n\n";
   // son partage
   $partage="//$samba_server/$groupe";
   $buf .= "dn:cn=smb:$partage,ou=local,ou=partages,$racine\n";
   $buf .= "objectClass:sambaFileShare\n";
   $buf .= "cn:smb:$partage\n";
   $buf .= "sambaShareName:$groupe\n";
   $buf .= "description:partage Classe $groupe\n";
   $buf .= "sambaShareDep:none\n";
   $buf .= "sambaShareURI:\\\\$samba_server\\$groupe\n";
   $buf .= "sambaShareAdmin:Administrateurs\n";
   $buf .= "sambaShareGroup:$groupe\n"; 
   $buf .= "location:/\n";
   $buf .= "sambaFilePath:/home/workgroups/$groupe\n";
   $buf .= "server:$samba_server\n\n\n";

   return ($buf);
}


// création d'un groupe quelconque et de son partage (optionnel)
function nouveau_groupe($sid, $gid, $groupe, $libelle, $partage) {
   global $samba_server, $racine;
   $rid=2*$gid+1001;
   // groupe
   $buf = "dn:cn=$groupe,ou=local,ou=groupes,$racine\n";
   $buf .= "objectClass:sambaGroupMapping\n";
   $buf .= "objectClass:posixGroup\n";
   $buf .= "cn:$groupe\n";
   $buf .= "gidNumber:$gid\n";
   $buf .= "sambaGroupType:2\n";
   $buf .= "sambaSID:$sid-$rid\n";
   $buf .= "description:$libelle\n\n\n";
   // son partage
   if ($partage) {
      $partage="//$samba_server/$groupe";
      $buf .= "dn:cn=smb:$partage,ou=local,ou=partages,$racine\n";
      $buf .= "objectClass:sambaFileShare\n";
      $buf .= "cn:smb:$partage\n";
      $buf .= "sambaShareName:$groupe\n";
      $buf .= "description:partage $libelle\n";
      $buf .= "sambaShareDep:none\n";
      $buf .= "sambaShareURI:\\\\$samba_server\\$groupe\n";
      $buf .= "sambaShareAdmin:Administrateurs\n";
      $buf .= "sambaShareGroup:$groupe\n"; 
      $buf .= "location:/\n";
      $buf .= "sambaFilePath:/home/workgroups/$groupe\n";
      $buf .= "server:$samba_server\n\n\n";
   }
   return ($buf);
}


// inscription d'une personne à un groupe
function membre($login,$groupe) {
   global $samba_server, $racine, $domain_mail;
   $buf = "dn:cn=$groupe,ou=local,ou=groupes,$racine\n";
   $buf .= "changetype:modify\n";
   if (!is_array($login)) {
      // 1 membre à la fois
      $buf .= "memberUid:$login\n";
   }
   else {
      // ajout multiple
      foreach ($login as $membre) {
         $buf .= "memberUid:$membre\n";
      }
   }
   $buf.="\n\n";
   return ($buf);
}


// ligne représentant l'appel au script de création de liste SYMPA
function liste_sympa($nom, $mail, $type) {
   global $samba_server, $racine, $domaine;
   return "sudo /usr/share/ead/create-list.pl ".
          "-m $mail ".
	  "-t $type ".
	  "-g $nom ".
	  "-d i-$domaine\n";
}
	  
// traitement des personnes non retrouvées dans l'annuaire
function restes ($info, $login_attribues,$nom_case,$politique=1) {
   $buf="<table>";
   $n=1;
   if ($politique==1) $check="CHECKED";
   else $check="";
   for ($i=0;$i<$info["count"];$i++) {
      $login=$info[$i]["uid"][0];
      if (!array_key_exists($login,$login_attribues)) {
	 if ($login=="admin")
	    $val="<input type=checkbox name='case_".$nom_case."[$n]' DISABLED> effacer ".$info[$i]["cn"][0]." (".$login.")";
	 else
	    $val="<input type=checkbox name='case_".$nom_case."[$n]' $check> effacer ".$info[$i]["cn"][0]." (".$login.")";
         $buf.="<input type=hidden name='tab_".$nom_case."[$n]' value='$login'>";
         if ($n++&1) $buf.="<tr><td>$val</td>\n"; // ligne impaire
	 else $buf.="<td>$val</td></tr>\n"; // ligne paire
      }
   }
   $buf.="</table>";	    
   return ($buf);
}

// upload des fichiers à partir d'un tableau
function loading ($fichiers) {
   $b="";
   foreach ($fichiers as $id => $nom) {
      $b.="Emplacement du fichier $id ($nom)<br>";
      $b.="<input type='file' name='$id'><br><br>";
   }
   return ($b);
}

// test de fichiers dbf
function test_fichier ($id,$nom,$f) {
      if (!$f) {
         $b.="Fichier $id non précisé<br>";
      } 
      elseif (!dbase_open($f,0)) {
         $b.="Base $id impossible à ouvrir<br>";
      }
   if ($b) return ($b.'<br><input type=button value="Retour" onclick="history.back();">');
   else return (0);
}


/*
Genere_mdp
-
génération aléatoire du mot de passe de l'utilisateur
-
Paramètres :
-
Résultat :
string : résultat de l'opération
-
Remarque :
mode de génération à voir !
-
*/

function Genere_mdp()
{
   for($i=0;$i<6;$i++){
      $mdp.=chr(rand(0,25)+97);
   }
   return($mdp);
}

/*
Copie_admin
-
code bash pour la copie des fichiers dans le répertoire de admin
*/

function Copie_admin()
{
   return ("adminhome=\"/home/a/admin/perso\"
if [ -e \${adminhome}/info.csv ]
then
        cp -f \${adminhome}/info.csv \${adminhome}/info.csv.bak
fi
cp -f /var/www/ead/extraction/tmp/info.csv \${adminhome}/
");

}

/*
Renvoit la valeur d'un attribut d'un noeud
*/
function get_attr($node, $attribut) 
{
   $attrs = domxml_attributes($node);
   foreach ($attrs as $attr) {
      if ($attr->name == $attribut) {
         return $attr->value;
      }
   }
   return "";
}

/*
Renvoit le contenu d'une balise d'un noeud
*/
function get_content($node, $balise)
{
   $parent = domxml_children($node);
   foreach ($parent as $element) {
      if (($element->type != 3) and ($element->tagname == $balise)) {
         $libelle = domxml_children($element);
	 return $libelle[0]->content;
      }
   }
   return "";
}

/*
*/
function is_tag($node, $tag){
   if (($node->type != 3) and ($node->tagname == $tag)) {
      return True;
   }else{
      return False;
   }
}

?>
